module.exports = function(browserifyOpts, browserifyMiddleware) {
	var lastModified = browserifyMiddleware.modified.getTime();
	return function(req, res, next) {
		//Pass a fake request through browserify so that we can update the bundle if it has changed
		browserifyMiddleware({'url': browserifyOpts.mount}, {'setHeader': function() {
			console.log("browserify:setHeader", arguments);
		}, 'end': function() {}} );
		if(lastModified != browserifyMiddleware.modified.getTime() )
		{
			console.log("Browserify bundle has changed!");
			lastModified = browserifyMiddleware.modified.getTime();
		}
		//Check to see if client is requesting the client script
		if(req.url.substr(0, browserifyOpts.mount.length) == browserifyOpts.mount)
		{
			//Add expires header - maximum recommended expiration is one year
			var d = new Date();
			d.setFullYear(d.getFullYear() + 1);
			res.setHeader('Expires', d.toUTCString() );
			res.setHeader('Cache-Control', 'public, max-age=31536000'); //31536000 = 365 days * 24 * 60 * 60
			//Add Last-Modified and Date headers
			res.setHeader('Date', new Date().toUTCString() );
			res.setHeader('Last-Modified', browserifyMiddleware.modified.toUTCString() );
			//Check If-Modified-Since request header
			if(Math.floor(new Date(req.headers["if-modified-since"]).getTime() / 1000) == Math.floor(browserifyMiddleware.modified.getTime() / 1000) )
				res.send(304);
			else
			{
				//Otherwise, let browserify serve up the actual script
				req.url = browserifyOpts.mount; //Trick browserify
				console.log("Browserify is handling this request");
				console.log("\tif-modified-since:", req.headers["if-modified-since"], new Date(req.headers["if-modified-since"]).getTime() );
				console.log("\tbrowserify modified date:", browserifyMiddleware.modified, browserifyMiddleware.modified.getTime());
				browserifyMiddleware(req, res, next);
			}
		}
		else next();
	};
}
